## 基于 element-ui 的表单

参考地址 http://element.eleme.io/1.3/#/zh-CN/component/form

### 需求

| 组件名称 | 组件路径 | 组件说明
| --- | --- | --- |
| nftn-el-input | /components/element-ui/input.vue | 根据类型不同有不同的展示 |
| nftn-el-form | /components/element-ui/main.vue | 带有 grid 布局的表单组件 |

### 依赖
| 组件名称 | 组件路径 | 组件说明
| --- | --- | --- |
| nftn-el-grid | /components/element-ui/grid.vue | 配置自适应网格布局 |

```viz
    digraph G {
        "nftn-el-form" -> "nftn-el-grid" -> "nftn-el-input";
        "nftn-el-input" -> text;
        "nftn-el-input" -> select;
        "nftn-el-input" -> datetimepicker;
        "nftn-el-input" -> "...";
    }
```
---
- [x] /componentselement-ui/grid/main.vue ___(20170621)___
    - [x] `v-bind:grid` 集成 grid 组件（按需创建 grid slots） ___(20170621√)___
    - [x] `v-bind:label-position` ___(20170622√)___
    - [x] `v-bind:label-width` ___(20170622√)___
    - [x] `v-bind:action-grid` 表单操作放哪里？ ___(20170622 ~ 20170626√)___
    - [x] `v-bind:inputs` 集成 input 组件 ___(20170622√)___
    ```javascript
        let input = {
            grid: String, // √
            label: String, // √
            name: String, // √
            rules: Array // √
        };
    ```
    - [x] `v-bind:rules` 集成 rules 组件 ___(20170622 ~ 20170626√)___
    - [x] `v-model: Object` 集成 input 数据 ___(20170622√)___
    - [x] 当 v-model 缺少数据时，补全 ___(20170622√)___
    ```javascript
    let formData = JSON.parse(JSON.stringify(this.value));
    this.inputs
        .filter(input => {
            return input.name && !formData[input.name];
        })
        .forEach(input => {
            formData[input.name] = '';
        });
    ```
    - [x] 添加 form.vue > grid 的 slot 接口 ___(20170626√)___
    ```html
    <nftn-el-form>
        <template slot="grid-0-0">
            替换 grid-0-0 区域的内容，如果不存在这个区域，无效！
        </template>
    <nftn-el-form>
    ```
    - [x] 添加 form.vue > input 的 slot 接口 ___(20170626√)___
    ```html
    <nftn-el-form>
        <template slot="inputname.label">
            替换 “inputname” 的label显示内容
        </template>
    <nftn-el-form>
    ```
    - [x] 添加 form.vue > grid 的 slot 接口 ___(20170626√)___
    ```html
    <nftn-el-form>
        <template slot="inputname.input">
            替换 “inputname” 的输入显示内容
        </template>
    <nftn-el-form>
    ```
---
- [x] /componentselement-ui/grid/input.vue ___(20170621)___
    - [x] `v-bind:label => String` ___(20170622√)___
    ```mermaid
    graph LR
        A[label:String] --> B{是否为空?};
        B --> |Y| C["不显示元素"]
        B --> |N| D["text + 空格（占个位）"]
    ```
    - [x] `v-bind:type => String` ___(20170622√)___
    - [x] `v-bind:name => String` ___(20170622√)___
    - [x] `v-bind:configs => Object` ___(20170622√)___
    - [x] `v-bind:datasource => Array` ___(20170622√)___
    - [x] `v-model` ___(20170622√)___
    - [x] 提供 label 的分发位置
    - [ ] 集成 input:text  ___(20170621)___
        - [x] 基础模式   ___(20170621√)___
        - [ ] autocomplete 模式 ___(20170622 ~ ?)___
    - [ ] 集成 select ___(20170622)___
        - [ ] 单选模式   ___(20170622 ~ ?)___
        - [ ] 多选模式 ___(20170622 ~ ?)___
    - [ ] 集成 datetimepicker ___(20170622 ~ ?)___
        - [ ] 日期模式   ___(20170622 ~ ?)___
        - [ ] 时间模式 ___(20170622 ~ ?)___
        - [ ] 日期+时间模式 ___(20170622 ~ ?)___
        - [ ] 日期范围模式 ___(20170622 ~ ?)___
        - [ ] 时间范围模式 ? ___(20170622 ~ ?)___
    - [x] 集成 radio ___(20170622√)___
    - [ ] 集成 checkbox ___(20170622 ~ ?)___
    - [ ] 集成 textarea ___(20170622 ~ ?)___
    - [ ] 集成 upload ___(20170622 ~ ?)___
    - [ ] 集成 switch ___(20170622 ~ ?)___
    - [ ] 集成 slider ___(20170622 ~ ?)___
